#!/usr/bin/python

program_name = "pycfg"
program_version = "0.1"

#
# PyCFG
#
# Copyright (C) 2002 Scott Scriven
#
# Released under the terms of the GNU Public License
#

class config:
  def __init__(self, name=program_name):
    import os
    try:
      home = os.environ["HOME"]
    except:
      home = "/tmp"

    self._name = name
    self._filenames = [
	"/etc/%s/%s.conf" % (self._name, self._name),
	"%s/.%s.conf" % (home, self._name),
	"%s/.%src" % (home, self._name),
	"%s/.%s/%s.conf" % (home, self._name, self._name),
	]
    self._namespace = {}

  def load(self):
    import os.path
    for name in self._filenames:
      if os.path.exists(name):
        self.parse(name)

    for k in self._namespace.keys():
      if k[0] != "_":
	setattr(self, k, self._namespace[k])

  def parse(self, filename):
    #print "parsing %s..." % filename
    try:
      execfile(filename, self._namespace)
    except:
      print "Error in config file %s" % filename
      import traceback, sys
      foo = traceback.format_exception(sys.exc_type,
                                       sys.exc_value,
                                       sys.exc_traceback)
      for item in foo:
        item = item[:-1]
        print item
      print "Press Enter to continue..."
      raw_input()

  def show(self):
    for k in self._namespace.keys():
      if k[0] != "_":
	print "%s: %s" % (k, self._namespace[k])

def run(args):
  cfg = config(program_name)
  cfg.load()
  cfg.show()

if __name__ == "__main__":
  import sys
  run(sys.argv[1:])
